#!/bin/sh
DESC="Maxwell 3 DSPG CSS"

set -e

do_start() {
	echo -n "Loading CSS... "
	/css/cssload.sh 2>&1 | tee /var/log/cssload.log
	set +e
	CSS_STATE_FILE="/sys/bus/platform/devices/8200000.css/state"
	while [ true ]
	do
	    grep loaded ${CSS_STATE_FILE} &>/dev/zero
	    if [ $? -eq 0 ]; then
		break
	    fi
	done
	echo "Done"
	set -e
	echo -n "Loading app_dsp... "
	/usr/bin/app_dsp 2>&1 | tee /var/log/app_dsp.log &
	echo "Done"
}

case "$1" in
  start)
	echo "Starting $DESC"
	do_start
	;;
  restart|force-reload)
	echo "Restarting $DESC"
	do_start
	;;
  *)
	echo "Usage: $0 {start|restart|force-reload}" >&2
	exit 1
	;;
esac

exit 0
