<?php

class firmwareupdate
{

  private $nvm;
  private $firmuptdserver;
  private $filename;
  private $down;
  private $firmwareupdatepath;
  private $filemanager;

  public function firmwareupdate()
  {
    $this->nvm = new settingscontroller();
    $this->firmuptdserver = $this->nvm->settingsGetOneParam('FirmwareDataServer');
    $this->firmwareupdatepath = $this->nvm->settingsGetOneParam('FirmwareDownloadPath');
    $this->down = new downloadfile();
    $this->filemanager = new filemanager();
  }

  /**
   * Method download file from server
   * 
   * @return boolean - return true if all is OK, return false if something gone FAIL
   */
  public function DownloadFileFromServer()
  {
    if (file_exists($this->firmwareupdatepath . DIRECTORY_SEPARATOR))
    {
      //DELETE ALL FILES IN DIRECTORY
      $this->filemanager->clearDir($this->firmwareupdatepath);

      if ($this->firmuptdserver != false)
      {
        //check if in FirmwareDataServer is extension .bin
        if (strpos($this->firmuptdserver, FIRMWAREUPDATEEXTENSION) == false)
        {

          if ($this->downloadXMLFirmwareFileFromServer() == true)
          {
            $this->nvm->settingsSetState(array('FirmwareUpdate.Filename' => $this->filename));
            $this->nvm->settingsSetState(array('FirmwareUpdate.Verify' => 'request'));
            return true;
          }
        }
        else
        {
          $filename = substr(strval($this->firmuptdserver), strpos(strval($this->firmuptdserver), FIRMWAREUPDATEFILENAME));

          if ($this->filemanager->downloadFileFromServer($this->firmuptdserver, $this->firmwareupdatepath, $filename))
          {
            $this->nvm->settingsSetState(array('FirmwareUpdate.Filename' => $filename));
            $this->nvm->settingsSetState(array('FirmwareUpdate.Verify' => 'request'));
            return true;
          }
          else
          {
            return false;
          }
        }
      }
      else
      {
        return false;
      }
    }
    else
    {
      return false;
    }
  }

  /**
   * Method upload file from PC
   * 
   * @param array $_file
   * @return boolean
   */
  public function SaveFileFromPC($_file)
  {
    try
    {
      $filename = null;
      if (file_exists($this->firmwareupdatepath . DIRECTORY_SEPARATOR))
      {
        $this->filemanager->clearDir($this->firmwareupdatepath);
        if ($this->filemanager->uploadFirmwareUpdate($_file, $this->firmwareupdatepath, $filename) == true)
        {
          $this->nvm->settingsSetState(array('FirmwareUpdate.Filename' => $filename));
          $this->nvm->settingsSetState(array('FirmwareUpdate.Verify' => 'request'));
          return true;
        }
        else
        {
          return false;
        }
      }
      else
      {
        mkdir($this->firmwareupdatepath . DIRECTORY_SEPARATOR);
      }
    }
    catch (Exception $ex)
    {
      $exc = new errorexceptionhandler();
      $exc->getException($ex);
    }
  }

  /**
   * Method download 
   * 
   * @return boolean
   */
  private function downloadXMLFirmwareFileFromServer()
  {
    //Search http:// in server address
    if (strpos($this->firmuptdserver, 'http://') == false)
      $this->firmuptdserver = 'http://' . $this->firmuptdserver;

    if ($this->filemanager->downloadFileFromServer($this->firmuptdserver . FIRMWAREUPDATEXMLFILENAME, WEBDIR, FIRMWAREUPDATEXMLFILENAME))
    {
      $xml = $this->parseXML();
      $this->filename = substr($xml['filename'], strpos($xml['filename'], FIRMWAREUPDATEFILENAME)); //get fiilename

      if ($this->filemanager->downloadFileFromServer($xml['filename'], $this->firmwareupdatepath, FIRMWAREUPDATEFILENAME . $xml['max'] . '.bin'))
      {
        unlink(WEBDIR . DIRECTORY_SEPARATOR . FIRMWAREUPDATEXMLFILENAME);
        return true;
      }
      else
      {
        return false;
      }
    }
    else
    {
      return false;
    }
  }

  /**
   * Method parse xml file 
   * 
   * @return boolean|array
   */
  private function parseXML()
  {
    try
    {
      $xmlfile = simplexml_load_file(WEBDIR . DIRECTORY_SEPARATOR . FIRMWAREUPDATEXMLFILENAME);
      $updateitem = array();

      foreach ($xmlfile->item as $val)
      {
        $ver = substr(strval($val->path), strpos(strval($val->path), FIRMWAREUPDATEFILENAME) + strlen(FIRMWAREUPDATEFILENAME), -4);
        $updateitem[$ver] = strval($val->path);
      }
      $max = max(array_keys($updateitem)); //The newest firmware version
      return array('max' => $max, 'filename' => $updateitem[$max]);
    }
    catch (Exception $ex)
    {
      return false;
    }
  }

  public function cronDownloadFileFromServer()
  {
    if (file_exists($this->firmwareupdatepath . DIRECTORY_SEPARATOR))
    {
      $this->filemanager->clearDir($this->firmwareupdatepath);
      if ($this->downloadXMLFirmwareFileFromServer() == true)
      {
        $this->nvm->settingsSetState(array('FirmwareUpdate.Filename' => $this->filename));
        return true;
      }
    }
    else
    {
      return false;
    }
  }

}
