<?php

function GetSessionToken()
{
  $token = '';
  if (array_key_exists('Authorization', getallheaders()))
  {
    $token = getallheaders()['Authorization'];
    $token = substr($token, 7);
  }
  return $token;
}

function GET_Text()
{

  $nvm = new settingscontroller();
  $lang = $nvm->settingsGetOneParam('WebUILanguage');
  $str = file_get_contents(FRONTENDPATH . "/languages/Text_" . $lang);
  echo $str;
}

function GET_Menu()
{

  $session = new sessionmanager();
  $token = GetSessionToken();
  $userID = $session->verifySession($token);
  switch ($userID)
  {
    case 0://not autheticated
      echo sessInfo();
      break;
    case 1://user
    case 2://admin
      echo file_get_contents("./Menu");
      break;
  }
  $session->closeConnection();
}

function GET_Tcpdump()
{
  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token);
  $down = new downloadfile();
  if ($userID && $userID == 2)
  {
    $down->DownloadFileOnPC(PCAPPATH);
  }
  else
  {
    echo getCodeMess('session', 'sesserr');
  }
  $session->closeConnection();
}

function GET_NtpSync()
{
  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token);
  if ($userID && ($userID == 2 || $userID == 1 ))
  {
    if (file_exists(NTPSYNCPATH))
    {
      echo file_get_contents(NTPSYNCPATH);
    }
    else
    {
      echo "";
    }
  }
  else
  {
    echo getCodeMess('session', 'sesserr');
  }
  $session->closeConnection();
}

function GET_SysLog($_args)
{
  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token);
  if ($userID == 2)//admin only
  {
    $matches = array();
    preg_match('/lastLine=(.*)[&$]/', $_args, $matches);
    if (sizeof($matches) > 0)
    {
      $_lastLine = $matches[1];
    }
    preg_match('/lastUpdate=(.*)/', $_args, $matches);
    if (sizeof($matches) > 0)
    {
      $_lastUpdate = $matches[1];
    }
    $debug = new debugManager;
    echo json_encode($debug->getLogs($_lastLine, $_lastUpdate));
  }
  else
  {
    echo getCodeMess('session', 'sesserr');
  }

  $session->closeConnection();
}

function GET_SIPdump()
{
  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token);
  if ($userID && $userID == 2)
  {
    echo shell_exec('tcpdump -AttttnNqr ' . SIPLOGPATH);
  }
  else
  {
    echo getCodeMess('session', 'sesserr');
  }
  $session->closeConnection();
}

function GET_Parameters($pathInfo)
{

  $session = new sessionmanager();
  $token = GetSessionToken();
  $userID = $session->verifySession($token, false);
  $nvm = new settingscontroller();
  $resource = explode("/", $pathInfo);
  $resourcelength = count($resource);
  $wildcardparameterinurl = ($resourcelength == 3) ? $resource[2] : null;

  if ($userID)
  {


    if ($resourcelength == 2)
    {
      $nvmrecv = $nvm->settingsGetAllParams($userID);
    }
    else if ($resourcelength == 3 && strpos($pathInfo, '[]') != false)
    {
      $nvmrecv = $nvm->settingsGetArrayValue(substr($wildcardparameterinurl, 0, strpos($wildcardparameterinurl, '[]')), $userID);
    }
    else
    {
      //Exception for Timestamp
      if ($wildcardparameterinurl == 'Timestamp')
      {
        $nvmrecv = $nvm->settingsGetTimestamp();
      }
      else
      {
        $nvmrecv = $nvm->settingsGetOneParam($wildcardparameterinurl);
      }
    }


    if ($nvmrecv != false)
    {
      echo json_encode($nvmrecv);
    }
  }
  else
  {
    if ($token != '')
    {


      if ($session->getCurrentLoginUser() == 2 && $token != $session->getToken())
      {
        echo getCodeMess('session', 'admlog');
      }
      else
      {
        echo getCodeMess('session', 'sesserr');
      }
    }
    else
    {

      $nvmrecv = $nvm->settingsGetAllParams($userID);
      if ($nvmrecv != false)
      {
        echo json_encode($nvmrecv);
      }
      else
      {
        
      }
    }
  }

  $session->closeConnection();
}

function GET_State($pathInfo)
{
  $session = new sessionmanager();
  $token = GetSessionToken();
  $userID = $session->verifySession($token, false);
  $nvm = new settingscontroller();
  $resource = explode("/", $pathInfo)[2];
  if ($userID)
  {
    $nvmrecv = $nvm->settingsGetState($resource);
    if ($nvmrecv != false && !is_object($nvmrecv))
    {
      echo json_encode(array($resource => $nvmrecv));
    }
    else
    {
      echo json_encode(array($resource => null));
    }
  }
  else
  {
    echo sessInfo();
  }
  $session->closeConnection();
}

function GET_SaveAllData()
{
  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token);
  if ($userID && $userID == 2)
  {
    $res = new saverestore();
    if ($res->saveAllDataToFile() != false)
    {
      $res->saveAllDataToFile();
    }
    else
    {
      echo getCodeMess('file', 'savefile');
    }
  }
  else
  {
    echo getCodeMess('session', 'sesserr');
  }
  $session->closeConnection();
}

function GET_SavePersonalizedData()
{
  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token);
  if ($userID)
  {
    $res = new saverestore();
    if ($res->savePersonalizedDataToFile() != false)
    {
      $res->savePersonalizedDataToFile();
    }
    else
    {
      echo getCodeMess('file', 'savefile');
    }
  }
  else
  {
    echo getCodeMess('session', 'sesserr');
  }
}

function GET_Test()
{
  $sett = new settingscontroller();


  echo json_encode($sett->settingsGetAllParams());
}

function GET_SysDump()
{
  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token);
  if ($userID && $userID == 2)
  {
    $savres = new saverestore();
    if ($savres->makeSysDumpZIP() != false)
    {
      $savres->makeSysDumpZIP();
    }
    else
    {
      echo getCodeMess('sysdump', 'sysdump');
    }
  }
  else
  {
    echo sessInfo();
  }
  $session->closeConnection();
}

function GET_Ringtones()
{
  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token, false);
  if ($userID)
  {
    $ringtones = new ringtones();
    echo json_encode($ringtones->getInfoRingtones());
  }
  else
  {
    echo sessInfo();
  }
  $session->closeConnection();
}

function GET_StorageStatus()
{
  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token, false);
  if ($userID)
  {
    $storageInfo = new storage();
    echo json_encode($storageInfo->getStorageUser());
  }
  else
  {
    echo sessInfo();
  }
  $session->closeConnection();
}

function GET_Status()
{
  
}

function sessInfo()
{
  $token = GetSessionToken();
  $session = new sessionmanager();
  if ($session->getCurrentLoginUser() == 2 && $token != $session->getToken())
  {
    return getCodeMess('session', 'admlog');
  }
  else
  {
    return getCodeMess('session', 'sesserr');
  }
}

function GET_Certificates()
{
  $session = new sessionmanager();
  $token = GetSessionToken();
  $userID = $session->verifySession($token, false);
  if ($userID && $userID == 2)
  {
    $cert = new certificates();
    echo $cert->getInfoCertificates();
  }
  else
  {
    if ($token != '')
    {
      echo sessInfo();
    }
    else
    {
      echo getCodeMess('session', 'sesserr');
    }
  }
  $session->closeConnection();
}

function GET_InvalidCertificates()
{
  $session = new sessionmanager();
  $token = GetSessionToken();
  $userID = $session->verifySession($token, false);
  if ($userID)
  {
    $cert = new certificates();
    echo $cert->getInfoInvalidCertificates();
  }
  else
  {
    if ($token != '')
    {
      echo sessInfo();
    }
    else
    {
      echo getCodeMess('session', 'sesserr');
    }
  }
  $session->closeConnection();
}

function GET_Images()
{
  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token, false);
  if ($userID)
  {
    $images = new images();
    echo json_encode($images->getInfoUserImages());
  }
  else
  {
    echo sessInfo();
  }
  $session->closeConnection();
}
