<?php

class images
{

  public function uploadImages($_files)
  {
    try
    {
      $result = false;
      $filemanager = new filemanager();
      $filename = null;
      if (($filemanager->sumFilesSize($_files) <= $filemanager->availableStorageSize(WEBUIIMGPATH, MAXALLOCATEDSIZE)))
      {
        if ($filemanager->checkFileCount(WEBUIIMGPATH) <= MAXFILESCOUNT)
        {
          $result = $filemanager->uploadFile($_files, 'fileoperations::replaceRenameFile', $_filters = array('SizeFilters' => array('function' => 'LessThan', 'condition' => array(MAXIMGSIZE)), 'TypeFilters' => unserialize(IMAGESMIMETYPE)), array('maxwell' => WEBUIIMGPATH), $filename);
          
          if ($result == FILEOK && isset($filename))
          {
            $this->cropImage($filename);
          }
        }
        else
        {
          $result = FILECOUNT;
        }
      }
      else
      {
        $result = ERRFILESIZE;
      }
      return $result;
    }
    catch (Exception $ex)
    {
      $exc = new errorexceptionhandler();
      $exc->getException($ex);
      return false;
    }
  }

  public function deleteImages($_image = array())
  {
    try
    {
      $deletedfile = 0;
      foreach ($_image as $value)
      {
        if (unlink($value))
        {
          $deletedfile++;
        }
      }

      $ret = false;
      if ($deletedfile == count($_image))
      {
        $ret = true;
      }
      return $ret;
    }
    catch (Exception $ex)
    {
      $exc = new errorexceptionhandler();
      $exc->getException($ex);
      return false;
    }
  }

  public function getInfoUserImages()
  {
    $return = array();
    if (file_exists(WEBUIIMGPATH))
    {
      $userfile = array();
      $iter = new DirectoryIterator(WEBUIIMGPATH);
      foreach ($iter as $file)
      {
        if (!$file->isDot())
        {
          $userfile[] = array('fileName' => $file->getFilename(), 'size' => $file->getSize());
        }
      }


      $return = $userfile;
    }

    return $this->sortArray($return);
  }

  private function sortArray($_array)
  {
    $ret = array();
    if (!empty($_array))
    {
      foreach ($_array as $key => $row)
      {
        $ringtones[$key] = $row['fileName'];
      }
      array_multisort($ringtones, SORT_NATURAL, $_array);
      $ret = $_array;
    }
    return $ret;
  }

  private function cropImage($_image)
  {
    try
    {
      $new_width = 320;
      $new_height = 240;
      $image = @imagecreatefromjpeg(WEBUIIMGPATH . DIRECTORY_SEPARATOR . $_image);
      if(!$image)
      {
        unlink(WEBUIIMGPATH . DIRECTORY_SEPARATOR . $_image);
        return false;
      }
      list($width, $height) = getimagesize(WEBUIIMGPATH . DIRECTORY_SEPARATOR . $_image);
      $internal_width = intval(($width / $height) * $new_height);
      $internal_height = intval(($height / $width) * $new_width);
      if (($new_width < $new_height) || ($internal_width > ($new_width)))
      {
        $internal_width = $new_width;
      }
      else
      {
        $internal_height = $new_height;
      }
      $background = imagecreatetruecolor($new_width, $new_height);
      $color = imagecolorallocate($background, 255, 255, 255);
      imagefill($background, 0, 0, $color);
      imagecopyresampled($background, $image, intval(($new_width - $internal_width) / 2), intval(($new_height - $internal_height) / 2), 0, 0, $internal_width, $internal_height, $width, $height);
      imagejpeg($background, WEBUIIMGPATH . DIRECTORY_SEPARATOR . $_image);
    }
    catch (Exception $ex)
    {
      $exc = new errorexceptionhandler();
      $exc->getException($ex);
      return false;
    }
  }

}
