<?php

class NVM
{

  private $_connect;
  private $_socket;
  private $_server = NVMHOST;
  private static $_instance = null;
  private $_count;

  private function NVM()
  {
    
  }

  public static function GetInstance()
  {
    if (self::$_instance == null)
    {
      self::$_instance = new NVM();
    }
    return self::$_instance;
  }

  /**
   * Method make connect with nvm
   * 
   * @return zmq object
   */
  private function ConnectService()
  {
    try
    {

      $this->_connect = new ZMQSocket(new ZMQContext(), ZMQ::SOCKET_REQ, 'my socket');
      $this->_connect->setSockOpt(ZMQ::SOCKOPT_LINGER, 0);
      $endpoints = $this->_connect->getEndpoints();
      if (!in_array(NVMHOST, $endpoints['connect']))
      {
        return $this->_connect->connect(NVMHOST);
      }
      else
      {
        return $this->_connect;
      }
    }
    catch (Exception $ex)
    {
      loger::LogErr($ex->getFile(), $ex->getLine(), $ex->getMessage(), $ex->getTraceAsString(), __METHOD__);
      return false;
    }
  }

  /**
   * Method send request to nvm
   * 
   * @param string $_method - method type exp. set,get
   * @param string $_request - json string which is send to nvm
   * @param string $_field - string with fileds are returned from nvm
   * @return string
   */
  private function SendRequest($_method = 'getColsE', $_request, $_value = null, $_field = null)
  {
    try
    {

      if (empty($_field) && $_method == 'getColsL')
      {
        $_requestfornvm = array('method' => $_method, 'param' => $_request, 'field' => 'webui');
      }
      else if (isset($_value) && $_method == 'setV')
      {
        $_requestfornvm = array('method' => $_method, 'param' => $_request, 'field' => 'webui', 'value' => $_value);
      }
      else if ($_method == 'setVList')
      {
        $_requestfornvm = array('method' => $_method, 'list' => $_request, 'field' => 'webui');
      }
      else if (!empty($_field) && $_method == 'getColsE')
      {
        $_requestfornvm = array('method' => $_method, 'param' => $_request, 'field' => 'webui', 'fields' => $_field);
      }
      else if (!empty($_field) && $_method == 'getColsL')
      {
        $_requestfornvm = array('method' => $_method, 'param' => $_request, 'field' => 'webui', 'fields' => $_field);
      }
      else if ($_method == 'getV' && preg_match('/^State\./', $_request) == 1)
      {
        $_requestfornvm = array('method' => $_method, 'param' => $_request);
      }
      else if ($_method == 'restore')
      {
        $_requestfornvm = array('method' => $_method);
      }
      else if ($_method == 'makeBackup')
      {
        if (isset($_request))
        {
          $_requestfornvm = array('method' => $_method, 'allSettings' => $_request);
        }
        else
        {
          $_requestfornvm = array('method' => $_method);
        }
      }
      else
      {
        $_requestfornvm = array('method' => $_method, 'param' => $_request, 'field' => 'webui');
      }

      $consocket = $this->ConnectService();
      $stringtab = str_split(json_encode($_requestfornvm), 255);
      $consocket->sendmulti($stringtab);
      $r = $consocket->recvMulti();

      return $r;
    }
    catch (Exception $ex)
    {
      loger::LogErr($ex->getFile(), $ex->getLine(), $ex->getMessage(), $ex->getTraceAsString(), __METHOD__);
      return false;
    }
  }

  /**
   * Method send multi request to nvm 
   * 
   * @param string $_method - method type exp. set,get
   * @param string $_request - json string which is send to nvm
   * @param type $_field - string with fileds are returned from nvm
   * @return array
   */
  public function GetMultiRecvFromNVM($_method = 'getColsL', $_request = null, $_field = null)
  {
    try
    {
      $response = array();
      $string = "";
      $resp = $this->SendRequest($_method, $_request, null, $_field);
      foreach ($resp as $val)
      {
        $string.=$val;
      }
      $respjson = json_decode($string);
      return $respjson;
    }
    catch (Exception $ex)
    {
      loger::LogErr($ex->getFile(), $ex->getLine(), $ex->getMessage(), $ex->getTraceAsString(), __METHOD__);
      return false;
    }
  }

  public function GetMultiRecvFromNVMLoop($_method = 'getColsE', $_request = null, $_field = null)
  {
    try
    {
      $response = array();
      $prefix = null;
      foreach ($_request as $k => $v)
      {

        $pattern = '/(\[)/'; //Search in parameters array index example. ProductName[i]

        if (preg_match($pattern, $v) != 1)
        {

          if ($v == 'Timestamp')
          {

            $resp['value'] = (int) exec("date -u +'%s'");
            $response[$v] = $resp;
          }
          else
          {

            $string = "";
            $resp = $this->SendRequest($_method, $v, null, $_field);
            foreach ($resp as $val)
            {
              $string.=$val;
            }
            $respjson = json_decode($string);
            $resp = $this->MakeJsonFileLoop($respjson);
          }


          if ($resp != false)
          {
            //Exception for Date&Time
            $response[$v] = $resp;
          }
          else
          {
            return false;
          }
        }
        else
        {

          //Example SIP[accountId].AccountName
          $prefix = substr($v, 0, strpos($v, '[')); //example SIP
          $v = substr($v, strpos($v, ']') + 2); //example AccountName
          //Example Request: SIP'%'AccountName

          $string = "";
          $resp = $this->SendRequest('getColsL', $prefix . '.%.' . $v, null, $_field);

          foreach ($resp as $val)
          {
            $string.=$val;
          }

          $respjson = json_decode($string);


          $resp = $this->MakeJsonFileLoop($respjson, null, $prefix);
          $response[$prefix][] = $resp;
        }
      }
      if (isset($prefix))
      {
        $response[$prefix] = $this->Group_array($response, $prefix);
      }

      
     return $response;
    }
    catch (Exception $ex)
    {
      loger::LogErr($ex->getFile(), $ex->getLine(), $ex->getMessage(), $ex->getTraceAsString(), __METHOD__);
      return false;
    }
  }

  /**
   * Method return value of column
   * 
   * @param string $_method - method type exp. set,get
   * @param string $_request - json string which is send to nvm
   * @return string
   */
  public function GetValueFromNVM($_method = 'getV', $_request)
  {
    try
    {

      $ret = $this->SendRequest($_method, $_request);

      foreach ($ret as $value)
      {
        $retjson = json_decode($value);

        if (isset($retjson->result))
        {
          return $retjson->result;
        }
        else
        {
          return $retjson;
        }
      }
    }
    catch (Exception $ex)
    {
      loger::LogErr($ex->getFile(), $ex->getLine(), $ex->getMessage(), $ex->getTraceAsString(), __METHOD__);
      return false;
    }
  }

  private function MakeJsonFileLoop($_data, $_onlyglobal = false, $_site = null)
  {
    try
    {


      $return;
      $tmp;
      if (isset($_data->result) && is_array($_data->result))
      {
        $this->_count = count($_data->result);

        foreach ($_data->result as $key => $val)
        {
          if (is_object($val))
          {
            $this->JsonFileFromLikeQuery($_data->result[$key], $return, null);
          }
          else
          {
            $this->JsonFile($val, $return, $_site);
          }
        }
      }
      else if (isset($_data->result) && !is_array($_data->result))
      {
        $val = $_data->result;
        $this->JsonFile($val, $return, $_site);
      }
      else
      {

        return false;
      }

      return $return;
    }
    catch (Exception $ex)
    {
      loger::LogErr($ex->getFile(), $ex->getLine(), $ex->getMessage(), print_r($_data, 1), __METHOD__);
      return false;
    }
  }

  private function Group_array($array, $prefix = null)
  {
    $tmp = array();

    $accountNumber = (int) $this->_count - 1;

    if (array_key_exists($prefix, $array) && isset($prefix))
    {
      for ($i = 0; $i <= $accountNumber; ++$i)
      {
        foreach ($array[$prefix] as $val)
        {

          if (is_array($val[$i]))
          {


            foreach ($val[$i] as $key => $v)
            {
              preg_match('/^[A-Z]+\.[0-9]+\./', strtoupper($key), $tmps);
              $newkey = substr($key, strlen($tmps[0]));
              $tmp[$i][$newkey] = $v;
            }
          }
        }
      }

      return $tmp;
    }
    else
    {
      return $array;
    }
  }

  private function JsonFile($val, &$return, $_site = null)
  {



    if (isset($val->range_max) && isset($val->range_min) && isset($val->value))
      $val->value = intval($val->value);

    if (isset($val->regexp))
    {
      $reg = array('regexp' => $val->regexp);
    }
    else
    {
      if (isset($val->range_min) && isset($val->range_max))
      {
        $reg = array('min' => $val->range_min, 'max' => $val->range_max);
      }
      else
      {
        $reg = array('regexp' => '');
      }
    }

    if (isset($_site))
    {
      $return[$_site][$val->webui] = array('value' => isset($val->value) ? $val->value : '', 'flags' => (string) hexdec($val->flags), 'validator' => $reg, 'options' => isset($val->enum) ? explode(',', $val->enum) : '');
    }
    else
    {
      if (in_array($val->webui, unserialize(EXCEPTIONARRAY)))
        $return = array('value' => isset($val->value) ? array_map('intval', explode(',', $val->value)) : array(), 'flags' => (string) hexdec($val->flags), 'validator' => $reg, 'options' => isset($val->enum) ? array_map('intval', explode(',', $val->enum)) : '');
      else
      {
        if (in_array($val->webui, unserialize(EXCEPTIONARRAYOPTIONS)))
          $return = array('value' => isset($val->value) ? $val->value : '', 'flags' => (string) hexdec($val->flags), 'validator' => $reg, 'options' => isset($val->enum) ? array_map('intval', explode(',', $val->enum)) : '');
        else
          $return = array('value' => isset($val->value) ? $val->value : '', 'flags' => (string) hexdec($val->flags), 'validator' => $reg, 'options' => isset($val->enum) ? explode(',', $val->enum) : '');
      }
    }
    return $return;
  }

  private function JsonFileFromLikeQuery($val, &$return, $_site)
  {

    if (isset($val->range_max) && isset($val->range_min))
      $val->value = intval($val->value);

    if (isset($val->regexp))
    {
      $reg = array('regexp' => $val->regexp);
    }
    else
    {
      if (isset($val->range_min) && isset($val->range_max))
      {
        $reg = array('min' => $val->range_min, 'max' => $val->range_max);
      }
      else
      {
        $reg = array('regexp' => '');
      }
    }

    if (isset($_site))
    {
      if (in_array($val->webui, unserialize(EXCEPTIONARRAY)))
        $return[$_site][$val->webui] = array('value' => isset($val->value) ? explode(',', $val->value) : array(), 'flags' => (string) hexdec($val->flags), 'validator' => $reg, 'options' => isset($val->enum) ? explode(',', $val->enum) : '');
      else
        $return[$_site][$val->webui] = array('value' => isset($val->value) ? $val->value : '', 'flags' => (string) hexdec($val->flags), 'validator' => $reg, 'options' => isset($val->enum) ? explode(',', $val->enum) : '');
    }
    else
    {
      if (in_array($val->webui, unserialize(EXCEPTIONARRAY)))
        $return[][$val->webui] = array('value' => isset($val->value) ? explode(',', $val->value) : array(), 'flags' => (string) hexdec($val->flags), 'validator' => $reg, 'options' => isset($val->enum) ? explode(',', $val->enum) : '');
      else
      {
        if (in_array($val->webui, unserialize(EXCEPTIONARRAYOPTIONS)))
          $return[][$val->webui] = array('value' => isset($val->value) ? $val->value : '', 'flags' => (string) hexdec($val->flags), 'validator' => $reg, 'options' => isset($val->enum) ? array_map('intval', explode(',', $val->enum)) : '');
        else
          $return[][$val->webui] = array('value' => isset($val->value) ? $val->value : '', 'flags' => (string) hexdec($val->flags), 'validator' => $reg, 'options' => isset($val->enum) ? explode(',', $val->enum) : '');
      }
    }

    return $return;
  }

  /**
   * Method save data to NVM
   * 
   * @param type $_request - Column name in database
   * @return boolean - Return TRUE if everything is save FALSE if something gone wrong
   */
  public function SaveValue($_key, $_value)
  {
    try
    {

      //Array is changed to string
      if (is_array($_value))
        $_value = implode(',', $_value);


      $set = json_decode($this->SendRequest('setV', $_key, $_value)[0]);

      if ($set->status == 'Ok')
        return true;
      else
        return false;
    }
    catch (Exception $ex)
    {
      loger::LogErr($ex->getFile(), $ex->getLine(), $ex->getMessage(), $ex->getTraceAsString(), __METHOD__);
      return false;
    }
  }

  /**
   * Save few object into nvm
   * 
   * @param array $_request - Array with object prepared to save example 
   * @return boolean - TRUE if everything is save FALSE if something gone wrong
   */
  public function SaveMultiValue($_request = array())
  {
    try
    {

      foreach ($_request as $key => $val)
      {
        //Change number to string
        if (is_numeric($val) || is_bool($val))
          $_request[$key] = (string) $val;




        if ($key == 'Timestamp')
        {
          exec("date -s @" . (int) $val . " +'%s'");
          $sql = new SQLite3('webui.db');
          $sql->exec('update webui_users set lastAccess=CURRENT_TIMESTAMP'); //UPDATE lastAccess when user changed timestamp
          if (count($_request) == 1)
          {
            return true;
          }
        }
        else
        {

          if (is_array($val))
          {

            $objcount = 0;
            $queryArray = array();
            foreach ($val as $k => $v)
            {
              //Objects with no properties are no longer considered empty.(stdClass())
              if (is_object($v) && $v != new stdClass())
              {
                foreach ($v as $keys => $value)
                {
                  //EXAMPLE JSON {SIP.0.Active:0}
                  $queryArray[$key . '.' . $k . '.' . $keys] = (string) $value;
                }

                $objcount++;
              }
            }
            if ($objcount != 0)
            {
              $_request = $queryArray;
            }
            else
            {
              //Change array to string separated by ,
              $_request[$key] = implode(',', $val);
            }
          }
        }
      }
      
      $string = "";
      unset($_request['Timestamp']); // DELETE Timestamp from array
      $resp = $this->SendRequest('setVList', $_request);

      foreach ($resp as $val)
      {
        $string.=$val;
      }
      $req = json_decode($string);

      if ($req->status == 'Ok')
      {
        return true;
      }
      else
      {
        return false;
      }
    }
    catch (Exception $ex)
    {
      loger::LogErr($ex->getFile(), $ex->getLine(), $ex->getMessage(), $ex->getTraceAsString(), __METHOD__);

      return false;
    }
  }

  public function SaveMultiValueState($_request = array())
  {
    try
    {

      $queryArray = array();
      foreach ($_request as $key => $val)
      {

        $queryArray['State.' . $key] = (string) $val;
      }


      $string = "";
      $resp = $this->SendRequest('setVList', $queryArray);

      foreach ($resp as $val)
      {
        $string.=$val;
      }
      $req = json_decode($string);

      if ($req->status == 'Ok')
      {
        return true;
      }
      else
      {
        return false;
      }
    }
    catch (Exception $ex)
    {
      loger::LogErr($ex->getFile(), $ex->getLine(), $ex->getMessage(), $ex->getTraceAsString(), __METHOD__);

      return false;
    }
  }

  public function SaveRestoreBackup($_method, $_request = null)
  {
    $set = json_decode($this->SendRequest($_method, $_request)[0]);

    if ($set->status == 'Ok')
      return true;
    else
      return false;
  }

}

?>