<?php

class ringtones
{

  public function uploadRingtones($_files)
  {
    try
    {
      $result = false;
      $filemanager = new filemanager();
      $filename = null;
      if (($filemanager->sumFilesSize($_files) <= $filemanager->availableStorageSize(RINGTONESPATH, MAXALLOCATEDSIZE)))
      {
        if ($filemanager->checkFileCount(RINGTONESPATH) <= MAXFILESCOUNT)
        {
          $result = $filemanager->uploadFile($_files, 'fileoperations::replaceRenameFile', array('TypeFilters' => unserialize(AUDIOMIMETYPE)), array('maxwell' => RINGTONESPATH), $filename);
        }
        else
        {
          $result = FILECOUNT;
        }
      }
      else
      {
        $result = ERRFILESIZE;
      }
      return $result;
    }
    catch (Exception $ex)
    {
      $exc = new errorexceptionhandler();
      $exc->getException($ex);
      return false;
    }
  }

  public function deleteRingtones($_ringtone = array())
  {
    try
    {
      $deletedfile = 0;
      foreach ($_ringtone as $value)
      {
        if (unlink(RINGTONESPATH . DIRECTORY_SEPARATOR . $value))
        {
          $deletedfile++;
        }
      }

      $ret = false;
      if ($deletedfile == count($_ringtone))
      {
        $ret = true;
      }
      return $ret;
    }
    catch (Exception $ex)
    {
      $exc = new errorexceptionhandler();
      $exc->getException($ex);
      return false;
    }
  }

  public function deleteAllRingtones()
  {
    try
    {
      $ret = false;
      if (file_exists(RINGTONESPATH))
      {
        $iter = new DirectoryIterator(RINGTONESPATH);
        $deletedfile = 0;
        $filecount = 0;
        foreach ($iter as $file)
        {
          if ($file->isFile())
          {
            $filecount++;
            if (unlink(RINGTONESPATH . DIRECTORY_SEPARATOR . $file->getFilename()))
            {
              $deletedfile++;
            }
          }
        }
        if ($deletedfile == $filecount)
        {
          $ret = true;
        }
      }
      return $ret;
    }
    catch (Exception $ex)
    {
      $exc = new errorexceptionhandler();
      $exc->getException($ex);
      return false;
    }
  }

  private function getInfoUserRingtones()
  {
    $return = array();
    if (file_exists(RINGTONESPATH))
    {
      $userfile = array();
      $iter = new DirectoryIterator(RINGTONESPATH);
      foreach ($iter as $file)
      {

        if (!$file->isDot())
        {
          $userfile[] = array('group' => 'user', 'path' => $file->getPathname(), 'size' => $file->getSize());
        }
      }
      $return = $userfile;
    }

    return $this->sortArray($return);
  }

  private function sortArray($_array)
  {
    $ret = array();
    if (!empty($_array))
    {
      foreach ($_array as $key => $row)
      {
        $ringtones[$key] = $row['path'];
      }
      array_multisort($ringtones, SORT_NATURAL, $_array);
      $ret = $_array;
    }
    return $ret;
  }

  private function getInfoInternalRingtones()
  {
    $return = array();
    if (file_exists(DEFAULTRINGTONESPATH))
    {
      $internalfile = array();
      $iter = new DirectoryIterator(DEFAULTRINGTONESPATH);
      foreach ($iter as $file)
      {
        if (!$file->isDot())
        {
          $internalfile[] = array('group' => 'factory', 'path' => $file->getPathname(), 'size' => $file->getSize());
        }
      }

      $return = $internalfile;
    }



    return $return;
  }

  public function getInfoRingtones()
  {

    $mergedarray = array_merge($this->getInfoUserRingtones(), $this->getInfoInternalRingtones());


    return $mergedarray;
  }

  private function checkFileCount()
  {
    $filescount = 1;

    $iter = new DirectoryIterator(RINGTONESPATH);
    foreach ($iter as $file)
    {
      if ($file->isFile())
      {
        $filescount++;
      }
    }



    return $filescount;
  }

  public function playRingtone($_path, $_group)
  {
    if ($_path != '' && $_group != '')
    {

      try
      {
        $nvm = new settingscontroller();
        if ($_group == 'factory')
        {
          $ringtonespath = DEFAULTRINGTONESPATH . DIRECTORY_SEPARATOR;
        }
        else
        {
          $ringtonespath = RINGTONESPATH . DIRECTORY_SEPARATOR;
        }

        $volume = $nvm->settingsGetOneParam('Volume');
        $nvm->settingsSendMessage('AudioCtr WebUI ', array(array("text" => "STOP_ALL"), array("FILE_NAME" => $ringtonespath . $_path, "VOLUME" => $volume, "text" => "PLAY_FILE_ONCE")));
        return true;
      }
      catch (Exception $ex)
      {
        $exc = new errorexceptionhandler();
        $exc->getException($ex);
        return false;
      }
    }
  }

}
