<?php

class saverestore
{

  private $nvm;

  public function saverestore()
  {
    $this->nvm = new settingscontroller();
  }

  /**
   * Method make zip archive with all settings from nvm
   * 
   * @return boolean - If all is ok returns true 
   */
  public function saveAllDataToFile()
  {
    if ($this->nvm->settingsCustomRequest(array('method' => 'makeBackup', 'allSettings' => true)))
    {

      return $this->saveDataToArchive();
    }
    else
    {
      return false;
    }
  }

  private function saveDataToArchive()
  {
    try
    {
      //GET FILE FROM DIRECTORIES
      if (file_exists(IMAGEUSERPATH) || file_exists(RINGTONESPATH) || file_exists(INTERNALPATH))
      {

        $this->MakeTmpDirIfNotExists();

        $this->MakeDirIfNotExists(RINGTONESDIRECTORY);
        $this->MakeDirIfNotExists(INTERNALDIRECTORY);
        $this->MakeDirIfNotExists(IMAGEDIRECTORY);

        if ($this->CopyFileToDir(NVMBACKUPFILEPATH, TMPDIR, NVMBACKUPFILE))
        {
          //COPY IMAGES TO TMP DIRECTORY
          $this->CopyUserCustomDataDirToTmpDirectory(IMAGEUSERPATH, IMAGEDIRECTORY, $this->ReturnDirContent(IMAGEUSERPATH));

          //COPY RINGTONES TO TMP DIRECTORY
          $this->CopyUserCustomDataDirToTmpDirectory(RINGTONESPATH, RINGTONESDIRECTORY, $this->ReturnDirContent(RINGTONESPATH));

          //COPY INTERNAL TO TMP DIRECTORY
          $this->CopyUserCustomDataDirToTmpDirectory(INTERNALPATH, INTERNALDIRECTORY, $this->ReturnDirContent(INTERNALPATH));
        }
      }
      else
      {
        $this->MakeTmpDirIfNotExists();
        $this->CopyFileToDir(NVMBACKUPFILEPATH, TMPDIR, NVMBACKUPFILE);
      }

      //MAKE ZIP ARCHIVE
      if (shell_exec('zip -P ' . ZIPPASSWORD . ' -r ' . RESTOREZIPARCH . ' ' . TMPDIR . DIRECTORY_SEPARATOR))
      {
        if (file_exists(RESTOREZIPARCH))
        {
          $down = new filemanager();
          $down->downloadFile(RESTOREZIPARCH);

          shell_exec('rm -R ' . TMPDIR . DIRECTORY_SEPARATOR); //DELETE TMP DIRECTORY
          unlink(RESTOREZIPARCH);
          exit;
        }
        else
        {
          return false;
        }
      }
      else
      {
        return false;
      }
    }
    catch (Exception $ex)
    {
      $exc = new errorexceptionhandler();
      $exc->getException($ex);
      return false;
    }
  }

  /**
   * Method make zip archive with specific users data and with images,ringtones and local contacts
   * 
   * @return boolean - If all is ok return true
   */
  public function savePersonalizedDataToFile()
  {
    if ($this->nvm->settingsCustomRequest(array('method' => 'makeBackup')))
    {
      return $this->saveDataToArchive();
    }
    else
    {
      return false;
    }
  }

  /**
   * Method restore user data form zip archive
   * 
   * @param array $_file - Array with info about uploaded file
   * @return boolean - If all is ok returns true
   */
  public function restoreDataFromFile($_file)
  {
    try
    {
      $down = new filemanager();
      $filename = null;
      $result = $down->uploadFile($_file, 'fileoperations::replaceFile', array(), array('maxwell' => WEBDIR), $filename);
      if ($result == FILEOK)
      {
        //UNPACKING ARCHIVE
        exec('unzip -P ' . ZIPPASSWORD . ' /www' . DIRECTORY_SEPARATOR . $filename . ' -d /www', $output, $ret);
        if ($ret == 0)
        {
          //We can't restore data from sysdump file
          if (file_exists(RESTOREDIRECTORY . DIRECTORY_SEPARATOR . NVMSYSDUMPFILE))
          {
            shell_exec('rm -R ' . '/www/www' . DIRECTORY_SEPARATOR); //DELETE TMP DIRECTORY
            unlink('/www' . DIRECTORY_SEPARATOR . $_file['file']['name']); //DELETE SYSDUMP ARCHIVE
            return false;
          }
          else
          {
            $this->CopyTmpToCustomDir(IMAGEDIRECTORY, IMAGEUSERPATH, $this->RestoreUserDataToDirectory(IMAGEDIRECTORY));
            $this->CopyTmpToCustomDir(RINGTONESDIRECTORY, RINGTONESPATH, $this->RestoreUserDataToDirectory(RINGTONESDIRECTORY));
            $this->CopyTmpToCustomDir(INTERNALDIRECTORY, INTERNALPATH, $this->RestoreUserDataToDirectory(INTERNALDIRECTORY));

            if ($this->CopyFileToDir(RESTOREDIRECTORY, NVMBACKUPFILEPATH, NVMBACKUPFILE))
            {
              if (file_exists(NVMBACKUPFILEPATH . DIRECTORY_SEPARATOR . NVMBACKUPFILE))
              {
                $nvm = new settingscontroller();
                if ($nvm->settingsSendMessage('PhoneUI WebUI ', array("text" => "configuration_restored")))
                {
                  if ($this->nvm->settingsCustomRequest(array('method' => 'restore')))
                  {
                    @shell_exec('rm -R ' . '/www/www' . DIRECTORY_SEPARATOR); //DELETE TMP DIRECTORY
                    @unlink('/www' . DIRECTORY_SEPARATOR . $filename); //DELETE FILE
                    return true;
                  }
                }
              }
            }
          }
        }
      }
      if (file_exists('/www' . DIRECTORY_SEPARATOR . $filename))
      {
        @shell_exec('rm -R ' . '/www/www' . DIRECTORY_SEPARATOR); //DELETE TMP DIRECTORY
        @unlink('/www' . DIRECTORY_SEPARATOR . $filename); //DELETE FILE
      }
      return false;
    }
    catch (ZMQException $ex)
    {
      $exc = new errorexceptionhandler();
      $exc->getException($ex);
      return false;
    }
  }

  private function RestoreUserDataToDirectory($_dir)
  {
    try
    {
      if (file_exists(WEBDIR . DIRECTORY_SEPARATOR . TMPDIR . DIRECTORY_SEPARATOR . $_dir . DIRECTORY_SEPARATOR))
      {
        foreach (new RecursiveIteratorIterator(
        new RecursiveDirectoryIterator(CUSTOMDIR . DIRECTORY_SEPARATOR . $_dir . DIRECTORY_SEPARATOR, FilesystemIterator::SKIP_DOTS | FilesystemIterator::UNIX_PATHS), RecursiveIteratorIterator::CHILD_FIRST) as $value)
        {
          $value->isFile() ? unlink($value) : rmdir($value);
        }
        return new DirectoryIterator(WEBDIR . DIRECTORY_SEPARATOR . TMPDIR . DIRECTORY_SEPARATOR . $_dir);
      }
      else
      {
        return array();
      }
    }
    catch (Exception $ex)
    {
      $exc = new errorexceptionhandler();
      $exc->getException($ex);
      return array();
    }
  }

  /**
   * Method get the users passwords from web database
   * 
   * @return string|boolean - If all is ok returns data with users pass else false
   */
  private function GetPassForWeb()
  {
    try
    {
      try
      {
        $sql = new SQLite3('webui.db');
        $sql->busyTimeout(10000);
        $query = "SELECT password FROM webui_users";
        $result = $sql->query($query);
        $data = '';

        while ($row = $result->fetchArray())
        {
          $data.=base64_encode($row['password']) . "\n";
        }

        $sql->close();

        return $data;
      }
      catch (Exception $ex)
      {
        return false;
      }
    }
    catch (Exception $ex)
    {
      return false;
    }
  }

  /**
   * Method restores users passwords from file to web database
   * 
   * @return boolean - If all is ok returns true
   */
  private function RestorePassForWebFromFile()
  {

    try
    {

      $file = file(RESTOREDIRECTORY . DIRECTORY_SEPARATOR . WEBPASSFILE);
      $sql = new SQLite3('webui.db');
      $sql->busyTimeout(10000);
      $result = 0;
      foreach ($file as $key => $val)
      {
        $query = "UPDATE webui_users SET password='" . base64_decode($val) . "' WHERE UserId= '" . ($key + 1) . "'";

        if ($sql->exec($query))
        {
          $result++;
        }
      }
      $sql->close();
      if ($result == count($file))
      {
        return true;
      }
      else
      {
        return false;
      }
    }
    catch (Exception $ex)
    {
      return false;
    }
  }

  public function makeSysDump()
  {
    try
    {
      if ($this->nvm->settingsCustomRequest(array('method' => 'makeSysdump')) == true)
      {
        if (file_exists(NVMSYSDUMPFILEPATH . DIRECTORY_SEPARATOR . NVMSYSDUMPFILE))
        {
          $this->nvm->settingsSetState(array('System.Sysdump' => 'request'));
          return true;
        }
        else
        {
          return false;
        }
      }
      else
      {
        return false;
      }
    }
    catch (Exception $ex)
    {
      $exc = new errorexceptionhandler();
      $exc->getException($ex);
      return false;
    }
  }

  public function makeSysDumpZIP()
  {
    try
    {
      if ($this->nvm->settingsCustomRequest(array('method' => 'makeSysdump')) == true)
      {
        $this->MakeTmpDirIfNotExists();

        if ($this->CopyFileToDir(NVMSYSDUMPFILEPATH, TMPDIR, NVMSYSDUMPFILE))
        {
          //MAKE ZIP ARCHIVE
          $filelocal = SYSDUMPZIPARCH . '_' . $this->nvm->settingsGetOneParam('MACAddress') . '.zip';

          if (shell_exec('zip -P ' . ZIPPASSWORDSYSDUMP . ' -r ' . $filelocal . ' ' . TMPDIR . DIRECTORY_SEPARATOR))
          {
            if (file_exists($filelocal))
            {
              $down = new filemanager();
              $down->downloadFile($filelocal);

              shell_exec('rm -R ' . TMPDIR . DIRECTORY_SEPARATOR); //DELETE TMP DIRECTORY
              unlink($filelocal);
              exit;
            }
            else
            {
              return false;
            }
          }
          else
          {
            return false;
          }
        }
        else
        {
          return false;
        }
      }
      else
      {
        return false;
      }
    }
    catch (Exception $ex)
    {
      $exc = new errorexceptionhandler();
      $exc->getException($ex);
      return false;
    }
  }

  private function CopyUserCustomDataDirToTmpDirectory($_sourcepath, $_destinationpath, $_dirobject)
  {
    try
    {
      $result = false;
      if (file_exists(TMPDIR . DIRECTORY_SEPARATOR . $_destinationpath . DIRECTORY_SEPARATOR))
      {
        $countallfiles = 0;
        $copysuccess = 0;
        foreach ($_dirobject as $value)
        {
          if ($value->isDot() == false)
          {
            if ($value->isFile())
            {
              $countallfiles++;
            }

            if (copy($_sourcepath . DIRECTORY_SEPARATOR . $value->getFilename(), TMPDIR . DIRECTORY_SEPARATOR . $_destinationpath . DIRECTORY_SEPARATOR . $value->getFilename()))
            {
              $copysuccess++;
            }
          }
        }
        if ($countallfiles == $copysuccess)
        {
          $result = true;
        }
      }
      return $result;
    }
    catch (Exception $ex)
    {
      $exc = new errorexceptionhandler();
      $exc->getException($ex);
      return false;
    }
  }

  private function CopyFileToDir($_sourcepath, $_destinationpath, $_filename)
  {
    if (copy($_sourcepath . DIRECTORY_SEPARATOR . $_filename, $_destinationpath . DIRECTORY_SEPARATOR . $_filename))
    {
      return true;
    }
    else
    {
      return false;
    }
  }

  private function ReturnDirContent($_dir)
  {
    return file_exists($_dir) ? new DirectoryIterator($_dir) : array();
  }

  private function MakeDirIfNotExists($_dir)
  {
    if (!file_exists(TMPDIR . DIRECTORY_SEPARATOR . $_dir . DIRECTORY_SEPARATOR))
    {
      mkdir((TMPDIR . DIRECTORY_SEPARATOR . $_dir . DIRECTORY_SEPARATOR));
    }
  }

  private function MakeTmpDirIfNotExists()
  {
    if (!file_exists(WEBDIR . DIRECTORY_SEPARATOR . 'tmpdir' . DIRECTORY_SEPARATOR))
    {
      mkdir((WEBDIR . DIRECTORY_SEPARATOR . 'tmpdir' . DIRECTORY_SEPARATOR));
    }
  }

  private function CopyTmpToCustomDir($_source, $_destination, $_object)
  {
    foreach ($_object as $val)
    {
      if ($val->isDot() == false)
      {
        copy(WEBDIR . DIRECTORY_SEPARATOR . TMPDIR . DIRECTORY_SEPARATOR . $_source . DIRECTORY_SEPARATOR . $val->getFilename(), $_destination . DIRECTORY_SEPARATOR . $val->getFilename());
      }
    }
  }

}
