<?php

/**
 * Description of sessionmanager
 *
 * @author hampel_ma
 */
class sessionmanager
{

  private $nvm;
  private $sesskey;
  private $passUser;
  private $passAdmin;
  private $busyTimeout = 10000;
  private $db = 'webui.db';
  private $sqlobject;
  private $accountType;

  public function sessionmanager()
  {

    $this->sqlobject = new SQLite3($this->db);
    $this->sqlobject->busyTimeout($this->busyTimeout);
    $this->nvm = new settingscontroller();
  }

  public function login($_pass)
  {
    $id = $this->checkLoginData($_pass);

    if ($id != 0)
    {


      if ($this->canLogin($id))
      {

        $this->sesskey = $this->generateSessId();
        return $this->setSession($id);
      }
      else
      {
        return 3;
      }
    }
    else
    {
      return false;
    }
  }

  private function sqliteObject()
  {

    return $this->sqlobject;
  }

  private function setSession($_id)
  {

    $sql = "update webui_users " .
            "set sessionID = '" . $this->sesskey . "'," .
            "lastAccess=CURRENT_TIMESTAMP" .
            " where userID='" . $_id . "';";
    $ret = $this->sqliteObject()->exec($sql);
    if (!$ret)
      return 0;


    return array('sessionID' => $this->sesskey, 'type' => $this->accountType);
  }

  private function checkLoginData($_pass)
  {

    $this->passUser = $this->nvm->settingsGetOneParam('UserPassword');
    $this->passAdmin = $this->nvm->settingsGetOneParam('AdminPassword');

    //Admin try to login
    if ($this->passAdmin === $_pass)
    {
      $this->accountType = 'admin';
      return 2;
    }
    else if ($this->passUser == $_pass)//User try to log
    {
      $this->accountType = 'user';
      return 1;
    }
    else
    {
      return 0;
    }
  }

  private function canLogin($accessLevel)
  {
    try
    {

      if ($this->getToken() != false)
      {
        $sql = "select CAST(strftime('%s', CURRENT_TIMESTAMP) as integer) - CAST(strftime('%s',lastAccess) as integer)  as delta from webui_users WHERE sessionID <> '' ";
        $ret = $this->sqliteObject()->query($sql);
        $resp = $ret->fetchArray();

        if (abs($resp['delta']) > LASTACCESSDELAY)
        {
          $this->clearSession();
          return true;
        }
        else
        {

          if ($accessLevel == 2 && $this->getCurrentLoginUser() == 1)
          {
            $this->logoutUser();
            return true;
          }
          else
          {
            return false;
          }
        }
      }
      else
      {
        return true;
      }
    }
    catch (Exception $ex)
    {
      $exc = new errorexceptionhandler();
      $exc->getException($ex);

      return false;
    }
  }

  public function logout($_sess)
  {
    try
    {
      $sql = "update webui_users set sessionID = null where sessionID='" . $_sess . "';";
      $ret = $this->sqliteObject()->exec($sql);
      if ($ret)
      {
        return true;
      }
      else
      {
        return false;
      }
    }
    catch (Exception $ex)
    {
      $exc = new errorexceptionhandler();
      $exc->getException($ex);

      return false;
    }
  }

  public function getUserMenu($userID)
  {
    try
    {
      $menu = array();
      $submenuRefs = array();
      $sql = "select text, url, parentID, itemID" .
              " from webui_menus," .
              "    webui_texts," .
              "   webui_resources" .
              " where userID=" . $userID .
              " and webui_menus.textID=webui_texts.textID" .
              " and webui_resources.resourceID = webui_menus.resourceID" .
              " order by parentID";

      $ret = $this->sqliteObject()->query($sql);
      if (!$ret)
        return 0;

      $submenuRefs[NULL] = &$menu;

      while ($row = $ret->fetchArray())
      {
        $itemID = $row['itemID'];
        $parentID = $row['parentID'];
        if ($parentID === NULL)
        {
          array_push($menu, ["text" => $row['text'], "url" => $row['url']]);
          $submenuRefs[$parentID] = &$menu;
          $submenuRefs[$itemID] = &$menu[count($menu) - 1];
        }
        else
        {
          //if (empty($menu[$parentID]["menu"]))
          if (empty($submenuRefs[$parentID]["menu"]))
          {
            $submenuRefs[$parentID]["menu"] = [];
          }
          array_push($submenuRefs[$parentID]["menu"], ["text" => $row['text'], "url" => $row['url']]);
          $submenuRefs[$itemID] = &$submenuRefs[$parentID]["menu"][count($submenuRefs[$parentID]["menu"]) - 1];
        }
      }
      return $menu;
    }
    catch (Exception $ex)
    {
      $exc = new errorexceptionhandler();
      $exc->getException($ex);

      return 0;
    }
  }

  public function getUserParameters($accessLevel, $resource)
  {
    try
    {
      /* $parameters = array('DeviceNameInNetwork' => 'IP.DeviceNameInNetwork', 'GratuitousARP' => 'IP.GratuitousARP', 'NetworkType' => 'IP.NetworkType', 'IPAddressType' => 'IP.IPAddressType',
        'IPv4Address' => 'IP.IPv4Address', 'IPv4SubnetMask' => 'IP.IPv4SubnetMask', 'IPv4StandardGateway' => 'IP.IPv4StandardGateway', 'IPv4PreferredDNSServer' => 'IP.IPv4PreferredDNSServer',
        'IPv4AlternateDNSServer' => 'IP.IPv4AlternateDNSServer', 'IPv6Address' => 'IP.IPv6Address', 'IPv6PrefixLength' => 'IP.IPv6PrefixLength', 'IPv6PreferredDNSServer' => 'IP.IPv6PreferredDNSServer',
        'IPv6AlternateDNSServer' => 'IP.IPv6AlternateDNSServer'
        ); */
      $parameters = array();
      $sql = "select  parameterName,resourceName " .
              "from webui_paramenters,webui_resourceparameters,webui_resources " .
              "where webui_paramenters.parameterID=webui_resourceparameters.parameterID " .
              "and  webui_resourceparameters.resourceID=webui_resources.resourceID " .
              "and  accessLevel<=" . $accessLevel . " and webui_resources.resourceName='" . $resource . "'";
      $ret = $this->sqliteObject()->query($sql);
      if (!$ret)
        return 0;


      while ($row = $ret->fetchArray())
      {
        array_push($parameters, $row['parameterName']);
      }

      return $parameters;
    }
    catch (Exception $ex)
    {
      $exc = new errorexceptionhandler();
      $exc->getException($ex);

      return 0;
    }
  }

  public function verifySession($_sessid, $_timestampupdate = true)
  {
    try
    {

      $sql = "select userID from webui_users " .
              "where sessionID='" . $_sessid . "';";
      $ret = $this->sqliteObject()->query($sql);
      if (!$ret)
        return 0;


      $row = $ret->fetchArray();
      $userId = $row['userID'];

      if ($row && $userId > 0)
      {
        if ($_timestampupdate == true)
        {
          $this->updateTimestamp($_sessid);
        }
        return $userId;
      }
      else
      {
        return 0;
      }
    }
    catch (Exception $ex)
    {
      $exc = new errorexceptionhandler();
      $exc->getException($ex);

      return 0;
    }
  }

  private function generateSessId()
  {
    return hash("sha256", uniqid(mt_rand(), true));
  }

  private function clearSession()
  {
    try
    {
      $sql2 = "UPDATE webui_users SET sessionID=null";


      if ($this->sqliteObject()->exec($sql2))
        return true;
      else
        return false;
    }
    catch (Exception $ex)
    {
      $exc = new errorexceptionhandler();
      $exc->getException($ex);
    }
  }

  public function getCurrentLoginUser()
  {
    try
    {
      $sql = "select userID from webui_users WHERE sessionID <> '' ";
      $ret = $this->sqliteObject()->query($sql);
      $resp = $ret->fetchArray();

      if ($resp['userID'] != null)
      {
        return $resp['userID'];
      }
      else
      {
        return 0;
      }
    }
    catch (Exception $ex)
    {
      $exc = new errorexceptionhandler();
      $exc->getException($ex);
      return 0;
    }
  }

  public function updateTimestamp($_seskey)
  {
    try
    {
      $sql = "update webui_users set lastAccess=CURRENT_TIMESTAMP WHERE sessionID='" . $_seskey . "';";
      if ($this->sqliteObject()->exec($sql))
      {
        return true;
      }
      else
      {
        return false;
      }
    }
    catch (Exception $ex)
    {
      $exc = new errorexceptionhandler();
      $exc->getException($ex);
      return false;
    }
  }

  private function logoutUser()
  {
    try
    {
      $sql = "update webui_users set sessionID=null WHERE userID=1;";
      if ($this->sqliteObject()->exec($sql))
      {
        return true;
      }
      else
      {
        return false;
      }
    }
    catch (Exception $ex)
    {
      $exc = new errorexceptionhandler();
      $exc->getException($ex);
      return false;
    }
  }

  public function closeConnection()
  {

    $this->sqliteObject()->close();
  }

  public function checkAccess($userAccess, $resourceName)
  {
    try
    {

      $sql = "SELECT accessLevel FROM webui_resources WHERE resourceName='" . $resourceName . "';";
      $ret = $this->sqliteObject()->query($sql);
      $resp = $ret->fetchArray();
      if ($resp['accessLevel'] <= 2 && $userAccess == 2)
      {
        return true;
      }
      else if ($resp['accessLevel'] < 2 && $userAccess == 1)
      {
        return true;
      }
      else
      {
        return false;
      }
    }
    catch (Exception $ex)
    {
      $exc = new errorexceptionhandler();
      $exc->getException($ex);

      return false;
    }
  }

  public function getToken()
  {
    try
    {
      $sql = "SELECT sessionID FROM webui_users WHERE sessionID <> ''";
      $ret = $this->sqliteObject()->query($sql);
      $resp = $ret->fetchArray();
      if ($resp['sessionID'] != '')
        return $resp['sessionID'];
      else
        return false;
    }
    catch (Exception $ex)
    {
      $exc = new errorexceptionhandler();
      $exc->getException($ex);

      return false;
    }
  }

}
