<?php

class viewjson implements InvmView
{

  public function viewGetRequestAllParams($_response)
  {
    $tab = $this->prepareResponseTab($_response);
    return $tab;
  }

  public function viewGetTimestamp()
  {
    $date = new DateTime();
    $timestamp = (int) $date->getTimestamp();
    return array('value' => $timestamp, 'flags' => 0, 'validator' => array('regexp' => ''));
  }

  private function getPrefix($val)
  {
    $pos = strpos($val, '.');
    $prefix = substr($val, 0, $pos);
    return $prefix;
  }

  private function getIndex($val)
  {
    $matches;
    preg_match('/\d+/', $val, $matches);
    return $matches[0];
  }

  private function getValue($val)
  {
    $index = $this->getIndex($val);
    $offset = strlen($index) + 1;
    return substr($val, strval(strpos($val, $this->getIndex($val)) + $offset));
  }

  private function prepareResponseTab($_response)
  {
    $tab = array();
    $tmp = array();


    foreach ($_response as $key => $value)
    {

      preg_match('/[a-zA-Z]+\.[0-9]+\.[a-zA-Z0-9]+/', $value->webui, $tmp);

      if (isset($tmp[0]))
      {

        $tab[$this->getPrefix($tmp[0])]
                [$this->getIndex($tmp[0])]
                [$this->getValue($tmp[0])] = $this->jsonFile($value);
      }
      else
      {
        $tmp = explode('.', $value->webui);
        if (count($tmp) == 1)
        {
          $tab[$tmp[0]] = $this->jsonFile($value);
        }
      }
    }



    return $tab;
  }

  private function jsonFile($val)
  {
    $return = array();

    $reg = isset($val->regexp) ? array('regexp' => $val->regexp) : array('regexp' => '');


    if (isset($val->range_max) && isset($val->range_min))
    {
      $reg['min'] = $val->range_min;
      $reg['max'] = $val->range_max;
      if (isset($val->value))
      {
        $val->value = intval($val->value);
      }
    }

    if (in_array($val->webui, unserialize(EXCEPTIONARRAY)))
      $return = array(
          'value' => isset($val->value) ? array_map('intval', explode(',', $val->value)) : array(),
          'flags' => intval($val->flags),
          'validator' => $reg,
          'options' => isset($val->enum) ? array_map('intval', explode(',', $val->enum)) : ''
      );
    else
    {
      if (in_array($val->webui, unserialize(EXCEPTIONARRAYOPTIONS)))
        $return = array(
            'value' => isset($val->value) ? $val->value : '',
            'flags' => intval($val->flags),
            'validator' => $reg,
            'options' => isset($val->enum) ? array_map('intval', explode(',', $val->enum)) : ''
        );
      else
        $return = array(
            'value' => isset($val->value) ? $val->value : '',
            'flags' => intval($val->flags),
            'validator' => $reg,
            'options' => isset($val->enum) ? explode(',', $val->enum) : ''
        );
    }

    return $return;
  }

  public function viewForOneObject($_response)
  {
    foreach ($_response as $value)
    {
      $retjson = json_decode(trim($value));

      if (isset($retjson->result))
      {
        return $retjson->result;
      }
      else
      {
        return $retjson;
      }
    }
  }

  public function viewGetArrayValue($_response)
  {
    return $this->prepareResponseTab($_response);
  }

  public function viewSaveMultiParams($_resp)
  {
    return $this->viewResponseSaveOneObject($_resp);
  }

  public function viewSaveOneParam($_resp)
  {
    return $this->viewResponseSaveOneObject($_resp);
  }

  public function viewStateForOneObject($_resp)
  {
    return $this->viewResponseSaveOneObject($_resp);
  }

  private function viewResponseSaveOneObject($_resp)
  {
    try
    {
      $string = '';
      foreach ($_resp as $val)
      {
        $string.=$val;
      }

      $req = json_decode(trim($string));

      if ($req->status == 'Ok')
      {
        return true;
      }
      else
      {
        if (isset($req->param))
          throw new Exception('Param' . ' ' . $req->param . ' ' . $req->status);
        else
          throw new Exception('NVM Exception' . ' ' . $req->status);
      }
    }
    catch (Exception $ex)
    {
      $exc = new errorexceptionhandler();
      $exc->getException($ex);
      return false;
    }
  }

  public function viewGetText($_str, $_key)
  {
    $jsontostring = json_decode(trim($_str), true);
    return $jsontostring[$_key];
  }

}
